with Ada.IO_Exceptions;
with Text_File;
with Text_File.Java_Properties;

package body Parse_File is

   -------------------
   -- Set_Type_File --
   -------------------

   procedure Set_Type_File (Type_File : T_Type_File) is
   begin
      TF := Type_File;
   end Set_Type_File;

   -------------------
   -- Set_File_Name --
   -------------------

   procedure Set_File_Name (File_Name : Unbounded_String) is
   begin
      FN := File_Name;
   end Set_File_Name;

   -----------
   -- Close --
   -----------

   procedure Init is
   begin
      case TF is
         when JAVA_PROPERTIES =>
            Text_File.Open_File (FN);
         when NA => raise File_Type_Not_Set;
      end case;
   exception
      when Ada.IO_Exceptions.Name_Error => raise File_Not_Found;
   end Init;


   -----------
   -- Close --
   -----------

   procedure Close is
   begin
      case TF is
         when JAVA_PROPERTIES =>
            Text_File.Close_File;
         when NA => raise File_Type_Not_Set;
      end case;
   end Close;

   ----------------------
   -- Get_Next_Element --
   ----------------------

   procedure Get_Next_Element (Key : out Unbounded_String;
                               Value : out Unbounded_String)
   is begin
      case TF is
         when JAVA_PROPERTIES =>
            Text_File.Java_Properties.Get_Next_Element (Key, Value);
         when NA => raise File_Type_Not_Set;
      end case;
   end Get_Next_Element;

end Parse_File;
