with Constants_CFD; use Constants_CFD;
with Ada.Strings.Fixed;

package body Text_File.Java_Properties is

   ----------------------
   -- Get_Next_Element --
   ----------------------

   procedure Get_Next_Element
     (Key : out Unbounded_String;
      Value : out Unbounded_String)
   is
      use Ada.Strings.Fixed;
      Line : constant String := Ada.Text_IO.Get_Line (File_Txt_IO);
      Pos_Equal : constant Natural := Index (Line, "=");
      Pos_Comment : constant Natural := Index (Line, "#");
   begin
      if (Pos_Comment = 1) then -- Comment on the begin of the line
         raise Comment_Line_Found;
      end if;
      Key := To_Unbounded_String (Line (1 .. Pos_Equal - 1));
      Value := To_Unbounded_String (Line (Pos_Equal + 1 .. Line'Last));
      if (Key = "") then
         raise Empty_Key;
      end if;
   end Get_Next_Element;

end Text_File.Java_Properties;
