with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with GNAT.OS_Lib;
with Ada.Text_IO;

package body Elog.Client is
   procedure Init (Client : in out T_Elog_Client;
                   Hostname : String;
                   Port_Number : Positive;
                   Logbook : String;
                   User_Passwd : String;
                   Author : String) is
   begin
      Init (T_Elog_Server_Information (Client), Hostname, Port_Number);
      Client.Logbook := To_Unbounded_String (Logbook);
      Client.User_Passwd := To_Unbounded_String (User_Passwd);
      Client.Author := To_Unbounded_String (Author);
   exception
      when Elog_Server_Information_Initialization_Error =>
         raise Elog_Server_Information_Initialization_Error;
      when others =>
         raise Elog_Client_Initialization_Error;
   end Init;

   procedure Sending_Log (Client : T_Elog_Client;
                          Message_Type : T_Message_Type;
                          Subject : String;
                          Message : String) is
      Tmp_Res : Integer;
   begin
      Tmp_Res := GNAT.OS_Lib.Spawn ("/usr/local/bin/grrr",
                                    (1 => new String'("-h"),
                                     2 => new String'(To_String (Client.Hostname)),
                                     3 => new String'("-p"),
                                     4 => new String'(Client.Port_Number'Img),
                                     5 => new String'("-l"),
                                     6 => new String'("""" & To_String (Client.Logbook) & """"),
                                     7 => new String'("-u"),
                                     8 => new String'(To_String (Client.User_Passwd)),
                                     9 => new String'("-a"),
                                     10 => new String'("Author=""" & To_String (Client.Author) & """"),
                                     11 => new String'("-a"),
                                     12 => new String'("Type=""" & Message_Type'Img & """"),
                                     13 => new String'("-a"),
                                     14 => new String'("Subject=""" & Subject & """"),
                                     15 => new String'("-v"),
                                     16 => new String'("-n"),
                                     17 => new String'("1"),
                                     18 => new String'("""" & Message & """")));
      Ada.Text_IO.Put_Line ("Elogging return : " & Tmp_Res'Img & "!");
   end Sending_Log;
end Elog.Client;
