--  <description>
--  This package is a child package of the print.numeric.
--  he allows the conversion of integer natural in hexadecimal or with a notation readable for the user.
--  </description>
--  <group>Print</group>
--  <c_version>1.0.0</c_version>




package Print.Numeric.Hexadecimal is



   function Hexa_To_String (N : Natural; Width : Natural := 0) return String;
   --  <summary>hexa_to_string take a value and return a string of the value in hexadecimal with the good notation
   --  (exemple: 0xA0FF).</summary>
   --  <parameter name="N">An Natural</parameter>
   --  <parameter name="Width">An Natural</parameter>
   --  <exception>No exception</exception>
   --  <seealso>Format</seealso>


   function To_Hexa (N : Natural; Width : Natural := 0) return String;
   --  <summary>To_Hexa take a value and return a string of the value in hexadecimal
   --  (exemple: A0FF).</summary>
   --  <parameter name="N">An Natural</parameter>
   --  <parameter name="Width">An Natural</parameter>
   --  <exception>No exception</exception>



   function Format (S : String) return String;
   --  <summary>Format add "0x" in front of the string in parameter </summary>
   --  <parameter name="S">An String</parameter>
   --  <exception>No exception</exception>


   function Ada_Format (S : String) return String;
   --  <summary>Ada_Format add "16#" in front of the string in parameter and add "#"after the parameter.
   --  </summary>
   --  <parameter name="S">An String</parameter>
   --  <exception>No exception</exception>


   function C_To_Ada_Format (S : String) return String;
   --  <summary>Format change the format hexadecimal for C in format hexadecimal for ADA
   --  </summary>
   --  <parameter Name="S">An String</parameter>
   --  <exception>No Exception</exception>

end Print.Numeric.Hexadecimal;
