--  with Ada.Text_IO;
--  with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body Print.Numeric is

   function Numeric_To_String (N : Natural) return Unbounded_String is
   begin
      if (N < 10) then
         return To_Unbounded_String (Integer'Image (N) (2 .. 2));
      else
         return To_Unbounded_String (Alphabet'Image (Alphabet'Val (N - 10)));
      end if;
   end Numeric_To_String;

   function Number_To_String (N : Natural; B : Base) return String is
   begin

      --  Warning : Base'Pos (Base_2) = 0 !!!
      return To_String (Base_To_String (N, Base'Pos (B) + 2));
   end Number_To_String;

   function Base_To_String (N : Natural; Base : Natural)
                           return Unbounded_String is
      Tmp : Natural := N;
      Val_Return : Unbounded_String := Null_Unbounded_String;
   begin
      while (Tmp > (Base - 1)) loop
         Val_Return := Numeric_To_String (Tmp rem Base) & Val_Return;
         Tmp := Tmp / Base;
      end loop;
      return Numeric_To_String (Tmp) & Val_Return;
   end Base_To_String;

   function Preformat (S : Unbounded_String; Width : Natural)
                      return Unbounded_String is
      Val_Return : Unbounded_String := S;
   begin
      for I in 1 .. (Width - Length (Val_Return)) loop
         Val_Return := "0" & Val_Return;
      end loop;
      return Val_Return;
   end Preformat;
end Print.Numeric;
