--  <description>
--  This package allows convertion of values hexadecimal,bytes or binary
--  in string.
--  </description>
--  <group>Print</group>
--  <c_version>1.0.0</c_version>


package Print_Utils_Base is
   type Hexadecimal is range 0 .. 15;
   type Octal is range 0 .. 7;
   type Binaire is range 0 .. 1;

   function To_String (N : Hexadecimal) return String;
   --  <summary>Take a value hexadecimal between 0 and 15 and converted in string of one caracter</summary>
   --  <parameter name="N">An Hexadecimal</parameter>
   --  <exception>No exception</exception>
   --  <seealso> Numeric_To_String</seealso>


   function To_String (N : Octal) return String;
   --  <summary>Take a value bytes between 0 and 7 and converted in string of one caracter</summary>
   --  <parameter name="N">An Hexadecimal</parameter>
   --  <exception>No exception</exception>
   --  <seealso>Numeric_To_String</seealso>
   function To_String (N : Binaire) return String;
   --  <summary>Take a value binary and converted in string of one caracter</summary>
   --  <parameter name="N">An Hexadecimal</parameter>
   --  <exception>No exception</exception>
   --  <seealso> Numeric_To_String</seealso>
private
   type Alphabet is (A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S,
                     T, U, V, W, X, Y, Z);

   function Numeric_To_String (N : Natural) return String;
   --  <summary>Take a value integer natural and converted in string</summary>
   --  <parameter name="N">An Natural</parameter>
   --  <exception>No exception</exception>



end Print_Utils_Base;

