--  with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Ada.Text_IO;
with Print.Numeric; use Print.Numeric;

package body Read.Numeric is

   function Read_Hex_Interne (Val : Unbounded_String) return Integer is
      Tmp_Val : Unbounded_String := Val;
   begin
      begin
         if (Ada.Strings.Unbounded.Slice (Val, 1, 2) /= "0X"
             and Ada.Strings.Unbounded.Slice (Val, 1, 2) /= "0x") then
            raise Constraint_Error;
         end if;
      exception
         when Ada.Strings.Index_Error =>
            raise Constraint_Error;
      end;
      return Integer'Value ("16#"
                            & Ada.Strings.Unbounded.Slice
                            (Tmp_Val, 3,
                             Ada.Strings.Unbounded.Length (Tmp_Val))
                            & "#");
   end Read_Hex_Interne;

   function Read_Dec_Interne (Val : Unbounded_String) return Integer is
   begin
      return Integer'Value (Ada.Strings.Unbounded.To_String (Val));
   end Read_Dec_Interne;

   function Read_Dec (Val : Unbounded_String) return Integer is
   begin
      return Read_Dec_Interne (Val);
   exception
      when Constraint_Error =>
         Ada.Text_IO.Put_Line (">" & To_String (Val)
                               & "< : Wrong kind of arguments.");
         Ada.Text_IO.Put_Line ("Should be a decimal number.");
         Ada.Text_IO.New_Line;
         raise Wrong_Type;
   end Read_Dec;

   function Read_Hex (Val : Unbounded_String) return Integer is
   begin
      return Read_Hex_Interne (Val);
   exception
      when Constraint_Error =>
         Ada.Text_IO.Put_Line (">" & To_String (Val)
                               & "< : Wrong kind of arguments.");
         Ada.Text_IO.Put_Line ("Should be an hexadecimal number.");
         Ada.Text_IO.New_Line;
         raise Wrong_Type;
   end Read_Hex;

   function Read_Hex_Dec (Val : Unbounded_String) return Integer is
   begin
--     Ada.Text_IO.Put_Line ("Val  convertir (Hex/Dec) : " & To_String (Val));
      return Read_Hex_Interne (Val);
   exception
      when Constraint_Error =>
         begin
            return Read_Dec_Interne (Val);
         exception
            when Constraint_Error =>
               Ada.Text_IO.Put_Line (">" & To_String (Val)
                                     & "< : Wrong kind of arguments.");
               Ada.Text_IO.Put_Line ("Should be a number.");
               Ada.Text_IO.New_Line;
               raise Wrong_Type;
         end;
   end Read_Hex_Dec;

end Read.Numeric;
