with Print.Numeric.Hexadecimal;
with AUnit.Assertions;

package body Print.Numeric.Hexadecimal.Unit_Test is


   function Equivalent_Values (Val1, Val2 : String) return Boolean is
   begin
      return Val1 = Val2;
   end Equivalent_Values;

   procedure Test_Equivalent_Hexa_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x0";
      Key2 : constant String := Hexa_To_String (Natural'First, 1);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 0 = caracter 0");
   end Test_Equivalent_Hexa_String_0;

   procedure Test_Equivalent_Hexa_String_1_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x001";
      Key2 : constant String := Hexa_To_String (1, 3);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 1 = caracter 0x001");
   end Test_Equivalent_Hexa_String_1_3;

   procedure Test_Equivalent_Hexa_String_2_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x10";
      Key2 : constant String := Hexa_To_String (16, 1);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 16 = caracter 0x10");
   end Test_Equivalent_Hexa_String_2_1;

   procedure Test_Equivalent_Hexa_String_87_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x0057";
      Key2 : constant String := Hexa_To_String (87, 4);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 87 = caracter 0x0057");
   end Test_Equivalent_Hexa_String_87_4;

   procedure Test_Equivalent_Hexa_String_28000_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x00006D60";
      Key2 : constant String := Hexa_To_String (28000, 8);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 28000 = caracter  0x00006D60 ");
   end Test_Equivalent_Hexa_String_28000_8;

   procedure Test_Equivalent_Hexa_String_last_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x7FFFFFFF";
      Key2 : constant String := Hexa_To_String (Natural'Last, 8);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural Natural'Last = caracter  0x7FFFFFFF");
   end Test_Equivalent_Hexa_String_last_8;

   procedure Test_Equivalent_Hexa_String_last_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x007FFFFFFF";
      Key2 : constant String := Hexa_To_String (Natural'Last, 10);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : Natural  Natural'Last = caracter 0x007FFFFFFF");
   end Test_Equivalent_Hexa_String_last_10;

   procedure Test_Equivalent_Hexa_String_last_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x7FFFFFFF";
      Key2 : constant String := Hexa_To_String (Natural'Last, 4);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural Natural'Last = caracter  0x7FFFFFFF");
   end Test_Equivalent_Hexa_String_last_4;

   procedure Test_Equivalent_Hexa_String_16_f (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x10";
      Key2 : constant String := Hexa_To_String (16, Natural'First);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 16 = caracter 0x10");
   end Test_Equivalent_Hexa_String_16_f;


   procedure Test_Equivalent_Hexa_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_Hexa (Natural'First, 1);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 0 = caracter 0");
   end Test_Equivalent_Hexa_0;

   procedure Test_Equivalent_Hexa_1_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "001";
      Key2 : constant String := To_Hexa (1, 3);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 1 = caracter 001");
   end Test_Equivalent_Hexa_1_3;

   procedure Test_Equivalent_Hexa_2_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := To_Hexa (16, 1);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 16 = caracter 10");
   end Test_Equivalent_Hexa_2_1;

   procedure Test_Equivalent_Hexa_87_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0057";
      Key2 : constant String := To_Hexa (87, 4);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 87 = caracter 0057");
   end Test_Equivalent_Hexa_87_4;

   procedure Test_Equivalent_Hexa_28000_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "00006D60";
      Key2 : constant String := To_Hexa (28000, 8);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural 28000 = caracter  00006D60 ");
   end Test_Equivalent_Hexa_28000_8;

   procedure Test_Equivalent_Hexa_last_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7FFFFFFF";
      Key2 : constant String := To_Hexa (Natural'Last, 8);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural   Natural'Last = caracter 7FFFFFFF");
   end Test_Equivalent_Hexa_last_8;

   procedure Test_Equivalent_Hexa_last_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "007FFFFFFF";
      Key2 : constant String := To_Hexa (Natural'Last, 10);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural Natural'Last = caracter 007FFFFFFF");
   end Test_Equivalent_Hexa_last_10;

   procedure Test_Equivalent_Hexa_last_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7FFFFFFF";
      Key2 : constant String := To_Hexa (Natural'Last, 4);
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : Natural   Natural'Last = caracter  7FFFFFFF");
   end Test_Equivalent_Hexa_last_4;




   procedure Test_Equivalent_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x0";
      Key2 : constant String := Format ("0");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0  => String 0x0");
   end Test_Equivalent_Format_0;

   procedure Test_Equivalent_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x001";
      Key2 : constant String := Format ("001");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 001  => String 0x001");
   end Test_Equivalent_Format_001;

   procedure Test_Equivalent_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x10";
      Key2 : constant String := Format ("10");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 10  => String 0x10");
   end Test_Equivalent_Format_10;

   procedure Test_Equivalent_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x0057";
      Key2 : constant String := Format ("0057");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0057  => String 0x0057");
   end Test_Equivalent_Format_0057;

   procedure Test_Equivalent_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x00006D60";
      Key2 : constant String := Format ("00006D60");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 00006D60  => String 0x00006D60");
   end Test_Equivalent_Format_6D60;

   procedure Test_Equivalent_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x7FFFFFFF";
      Key2 : constant String := Format ("7FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 7FFFFFFF => String 0x7FFFFFFF");
   end Test_Equivalent_Format_last8;

   procedure Test_Equivalent_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x007FFFFFFF";
      Key2 : constant String := Format ("007FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 007FFFFFFF  => String 0x007FFFFFFF ");
   end Test_Equivalent_Format_last10;

   procedure Test_Equivalent_Format_S (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0x ";
      Key2 : constant String := Format (" ");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter ' '  => String '0x ' ");
   end Test_Equivalent_Format_S;



   procedure Test_Equivalent_Ada_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#0#";
      Key2 : constant String := Ada_Format ("0");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0  => String 16#0# ");
   end Test_Equivalent_Ada_Format_0;

   procedure Test_Equivalent_Ada_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#001#";
      Key2 : constant String := Ada_Format ("001");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 001  => String 16#001# ");
   end Test_Equivalent_Ada_Format_001;

   procedure Test_Equivalent_Ada_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#10#";
      Key2 : constant String := Ada_Format ("10");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 10  => String 16#10# ");
   end Test_Equivalent_Ada_Format_10;

   procedure Test_Equivalent_Ada_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#0057#";
      Key2 : constant String := Ada_Format ("0057");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0057  => String 16#0057# ");
   end Test_Equivalent_Ada_Format_0057;

   procedure Test_Equivalent_Ada_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#00006D60#";
      Key2 : constant String := Ada_Format ("00006D60");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 00006D60  => String 16#00006D60# ");
   end Test_Equivalent_Ada_Format_6D60;

   procedure Test_Equivalent_Ada_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#7FFFFFFF#";
      Key2 : constant String := Ada_Format ("7FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 7FFFFFFF  => String 16#7FFFFFFF#");
   end Test_Equivalent_Ada_Format_last8;

   procedure Test_Equivalent_Ada_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#007FFFFFFF#";
      Key2 : constant String := Ada_Format ("007FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 007FFFFFFF  => String 16#007FFFFFFF#");
   end Test_Equivalent_Ada_Format_last10;

   procedure Test_Equivalent_Ada_Format_S (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16# #";
      Key2 : constant String := Ada_Format (" ");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter '0'  => String 16# #");
   end Test_Equivalent_Ada_Format_S;





   procedure Test_Equivalent_C_To_Ada_Format_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#0#";
      Key2 : constant String := C_To_Ada_Format ("0x0");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0x0  => String 16#0#");
   end Test_Equivalent_C_To_Ada_Format_0;

   procedure Test_Equivalent_C_To_Ada_Format_001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#001#";
      Key2 : constant String := C_To_Ada_Format ("0x001");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0x001  => String 16#001# ");
   end Test_Equivalent_C_To_Ada_Format_001;

   procedure Test_Equivalent_C_To_Ada_Format_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#10#";
      Key2 : constant String := C_To_Ada_Format ("0x10");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0x10  => String 16#10# ");
   end Test_Equivalent_C_To_Ada_Format_10;

   procedure Test_Equivalent_C_To_Ada_Format_0057 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#0057#";
      Key2 : constant String := C_To_Ada_Format ("0x0057");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2), "Assertion : String caracter 0x0057  => String 16#0057# ");
   end Test_Equivalent_C_To_Ada_Format_0057;

   procedure Test_Equivalent_C_To_Ada_Format_6D60 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#00006D60#";
      Key2 : constant String := C_To_Ada_Format ("0x00006D60");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 0x00006D60  => String 16#00006D60# ");
   end Test_Equivalent_C_To_Ada_Format_6D60;

   procedure Test_Equivalent_C_To_Ada_Format_last8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#7FFFFFFF#";
      Key2 : constant String := C_To_Ada_Format ("0x7FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 0x7FFFFFFF  => String 16#7FFFFFFF# ");
   end Test_Equivalent_C_To_Ada_Format_last8;

   procedure Test_Equivalent_C_To_Ada_Format_last10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "16#007FFFFFFF#";
      Key2 : constant String := C_To_Ada_Format ("0x007FFFFFFF");
   begin
      AUnit.Assertions.Assert (Equivalent_Values (Key1, Key2),
			       "Assertion : String caracter 0x007FFFFFFF  => String 16#007FFFFFFF#");
   end Test_Equivalent_C_To_Ada_Format_last10;






   procedure Register_Tests (T : in out T_Print_Test_Case) is

      use AUnit.Test_Cases.Registration;
   begin

      Register_Routine (T, Test_Equivalent_Hexa_String_0'Access,
			"Hexa_To_String => Value hexadecimal of natural 0 egal caracter 0x0");
      Register_Routine (T, Test_Equivalent_Hexa_String_1_3'Access,
			"Hexa_To_String => Value hexadecimal of natural 1 egal caracter 0x001");
      Register_Routine (T, Test_Equivalent_Hexa_String_2_1'Access,
			"Hexa_To_String => Value hexadecimal of natural 2 egal caracter 0x10");
      Register_Routine (T, Test_Equivalent_Hexa_String_87_4'Access,
			"Hexa_To_String => Value hexadecimal of natural 87 egal caracter 0x0057");
      Register_Routine (T, Test_Equivalent_Hexa_String_28000_8'Access,
			"Hexa_To_String => Value hexadecimal of natural 28000 egal caracter 0x00006D60");
      Register_Routine (T, Test_Equivalent_Hexa_String_last_8'Access,
			"Hexa_To_String => Value hexadecimal of natural'last egal caracter 0x7FFFFFFF");
      Register_Routine (T, Test_Equivalent_Hexa_String_last_10'Access,
			"Hexa_To_String => Value hexadecimal of natural'last egal caracter 0x007FFFFFFF");
      Register_Routine (T, Test_Equivalent_Hexa_String_last_4'Access,
			"Hexa_To_String => Value hexadecimal of natural'last egal caracter 0x7FFFFFFF");
      Register_Routine (T, Test_Equivalent_Hexa_String_16_f'Access,
			"Hexa_To_String => Value hexadecimal of natural'last egal caracter 0x10");

      Register_Routine (T, Test_Equivalent_Hexa_0'Access,
			"To_Hexa => Value hexadecimal of natural 0 egal caracter 0");
      Register_Routine (T, Test_Equivalent_Hexa_1_3'Access,
			"To_Hexa => Value hexadecimal of natural 1 egal caracter 001");
      Register_Routine (T, Test_Equivalent_Hexa_2_1'Access,
			"To_Hexa => Value hexadecimal of natural 2 egal caracter 10");
      Register_Routine (T, Test_Equivalent_Hexa_87_4'Access,
			"To_Hexa => Value hexadecimal of natural 87 egal caracter 0057");
      Register_Routine (T, Test_Equivalent_Hexa_28000_8'Access,
			"To_Hexa => Value hexadecimal of natural 28000 egal caracter 00006D60");
      Register_Routine (T, Test_Equivalent_Hexa_last_8'Access,
			"To_Hexa => Value hexadecimal of natural'last egal caracter 7FFFFFFF");
      Register_Routine (T, Test_Equivalent_Hexa_last_10'Access,
			"To_Hexa => Value hexadecimal of natural'last egal caracter 007FFFFFFF");
      Register_Routine (T, Test_Equivalent_Hexa_last_4'Access,
			"To_Hexa => Value hexadecimal of natural'last egal caracter 7FFFFFFF");

      Register_Routine (T, Test_Equivalent_Format_0'Access, "Format => Add prefix 0x at 0");
      Register_Routine (T, Test_Equivalent_Format_001'Access, "Format => Add prefix 0x at 001");
      Register_Routine (T, Test_Equivalent_Format_10'Access, "Format => Add prefix 0x at 10");
      Register_Routine (T, Test_Equivalent_Format_0057'Access, "Format => Add prefix 0x at 0057");
      Register_Routine (T, Test_Equivalent_Format_6D60'Access, "Format => Add prefix 0x at 00006D60");
      Register_Routine (T, Test_Equivalent_Format_last8'Access, "Format => Add prefix 0x at 7FFFFFFF");
      Register_Routine (T, Test_Equivalent_Format_last10'Access, "Format => Add prefix 0x at 007FFFFFFF");
      Register_Routine (T, Test_Equivalent_Format_S'Access, "Format => Add prefix '0x ' at ' '");


      Register_Routine (T, Test_Equivalent_Ada_Format_0'Access, "Ada_Format => Add prefix 16# and sufix # at 0");
      Register_Routine (T, Test_Equivalent_Ada_Format_001'Access, "Ada_Format => Add prefix 16# and sufix # at 001");
      Register_Routine (T, Test_Equivalent_Ada_Format_10'Access, "Ada_Format => Add prefix 16# and sufix # at 10");
      Register_Routine (T, Test_Equivalent_Ada_Format_0057'Access, "Ada_Format => Add prefix 16# and sufix # at 0057");
      Register_Routine (T, Test_Equivalent_Ada_Format_6D60'Access,
			"Ada_Format => Add prefix 16# and sufix # at 00006D60");
      Register_Routine (T, Test_Equivalent_Ada_Format_last8'Access,
			"Ada_Format => Add prefix 16# and sufix # at 7FFFFFFF");
      Register_Routine (T, Test_Equivalent_Ada_Format_last10'Access,
			"Ada_Format => Add prefix 16# and sufix # at 007FFFFFFF");
      Register_Routine (T, Test_Equivalent_Ada_Format_S'Access, "Ada_Format => Add prefix 16# and sufix # at ' '");

      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_0'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x0");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_001'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x001");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_10'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x10");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_0057'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x0057");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_6D60'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x00006D60");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_last8'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x7FFFFFFF");
      Register_Routine (T, Test_Equivalent_C_To_Ada_Format_last10'Access,
			"C_To_Ada_Format => Delete the prefix 0x add prefix 16# and sufix # at 0x007FFFFFFF");

   end Register_Tests;




   function Name (T : T_Print_Test_Case) return Message_String is
      pragma Unreferenced (T);
   begin
      return new String'("print module tests");
   end Name;

end Print.Numeric.Hexadecimal.Unit_Test;
