with Print.Numeric.Unit_Test;
with AUnit.Assertions; use AUnit.Assertions;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Ada.Text_IO;

package body Print.Numeric.Unit_Test is

   function Equivalent_Values (Val1, Val2 : String) return Boolean is
   begin
      return Val1 = Val2;
   end Equivalent_Values;

   procedure Test_Last is
   begin
      Ada.Text_IO.Put_Line (Natural'Size'Img & "bits");
      Ada.Text_IO.Put_Line (Natural'Last'Img & "last number of decimal");
   end Test_Last;

   procedure Number_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := Number_To_String (Natural'First, Base_2);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 0 , key2 : string = natural'first and base_2");
   end Number_To_String_0;

   procedure Number_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := Number_To_String (Natural'First, Base_16);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 0 , key2 : string = natural'first and base_16");
   end Number_To_String_1;

   procedure Number_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (2, Base_2);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 2 and base_2");
   end Number_To_String_2;

   procedure Number_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (3, Base_3);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 3 and base_3");
   end Number_To_String_3;

   procedure Number_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (4, Base_4);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 4 and base_4");
   end Number_To_String_4;

   procedure Number_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (5, Base_5);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 5 and base_5");
   end Number_To_String_5;

   procedure Number_To_String_6 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (6, Base_6);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 6 and base_6");
   end Number_To_String_6;

   procedure Number_To_String_7 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (7, Base_7);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 7 and base_7");
   end Number_To_String_7;

   procedure Number_To_String_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (8, Base_8);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 8 and base_8");
   end Number_To_String_8;

   procedure Number_To_String_9 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (9, Base_9);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 9 and base_9");
   end Number_To_String_9;

   procedure Number_To_String_10 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (10, Base_10);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 10 and base_10");
   end Number_To_String_10;

   procedure Number_To_String_11 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (11, Base_11);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 11 and base_11");
   end Number_To_String_11;

   procedure Number_To_String_12 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (12, Base_12);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 12 and base_12");
   end Number_To_String_12;

   procedure Number_To_String_13 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (13, Base_13);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 13 and base_13");
   end Number_To_String_13;

   procedure Number_To_String_14 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (14, Base_14);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 14 and base_14");
   end Number_To_String_14;

   procedure Number_To_String_15 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (15, Base_15);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 15 and base_15");
   end Number_To_String_15;

   procedure Number_To_String_16 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := Number_To_String (16, Base_16);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = 16 and base_16");
   end Number_To_String_16;

   procedure Number_To_String_17 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1111111111111111111111111111111";
      Key2 : constant String := Number_To_String (Natural'Last, Base_2);
   begin
      Assert (Equivalent_Values (Key1, Key2),
	      "key1 : string = 111 1111 1111 1111 1111 1111 1111 1111 , key2 : string = Natural'Last and base_2");
   end Number_To_String_17;

   procedure Number_To_String_18 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7FFFFFFF";
      Key2 : constant String := Number_To_String (Natural'Last, Base_16);
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 7FFFFFFF , key2 : string = Natural'Last and base_16");
   end Number_To_String_18;

   procedure Base_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_String (Base_To_String (Natural'First, 2));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 0 , key2 : string = natural'first and 2");
   end Base_To_String_0;

   procedure Base_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_String (Base_To_String (Natural'First, 16));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 0 , key2 : string = natural'first and 16");
   end Base_To_String_1;

   procedure Base_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "11001";
      Key2 : constant String := To_String (Base_To_String (25, 2));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 11001 , key2 : string = 25 and 2");
   end Base_To_String_2;

   procedure Base_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "31";
      Key2 : constant String := To_String (Base_To_String (25, 8));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 31 , key2 : string = 25 and 2");
   end Base_To_String_3;

   procedure Base_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "19";
      Key2 : constant String := To_String (Base_To_String (25, 16));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 19 , key2 : string = 25 and 16");
   end Base_To_String_4;

   procedure Base_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "A1";
      Key2 : constant String := To_String (Base_To_String (161, 16));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = A1 , key2 : string = 161 and 16");
   end Base_To_String_5;

   procedure Base_To_String_6 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1111111111111111111111111111111";
      Key2 : constant String := To_String (Base_To_String (Natural'Last, 2));
   begin
      Assert (Equivalent_Values (Key1, Key2),
	      "key1 : string = 1111111111111111111111111111111 , key2 : string = natural'last and 2");
   end Base_To_String_6;

   procedure Base_To_String_7 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7FFFFFFF";
      Key2 : constant String := To_String (Base_To_String (Natural'Last, 16));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 7FFFFFFF , key2 : string = natural'last and 16");
   end Base_To_String_7;

   procedure Base_To_String_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "10";
      Key2 : constant String := To_String (Base_To_String (Natural'Last, Natural'Last));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 10 , key2 : string = natural'last and natural'last");
   end Base_To_String_8;


   procedure Preformat_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "01";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String ("1"), 2));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 01 , key2 : string = 1 and 2");
   end Preformat_0;

   procedure Preformat_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1001";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String ("1001"), 2));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 1001 , key2 : string = 1001 and 2");
   end Preformat_1;

   procedure Preformat_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "00001001";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String ("1001"), 8));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : string = 00001001 , key2 : string = 1001 and 8");
   end Preformat_2;

   procedure Preformat_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "00000abc";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String ("abc"), 8));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 = 00000abc , key2 = abc and 8");
   end Preformat_3;

   procedure Preformat_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0#@.";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String ("#@."), 4));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 = 0#@. , key2 = #@. and 4");
   end Preformat_4;

   procedure Preformat_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "000 ";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String (" "), 4));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 = (espace) , key2 = espace and 4");
   end Preformat_5;

   procedure Preformat_6 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0000";
      Key2 : constant String := To_String (Preformat (To_Unbounded_String (""), 4));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key = nothing , key2 = nothing and 4");
   end Preformat_6;


   procedure Not_Numeric_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := " 0";
      Key2 : constant String := To_String (Numeric_To_String (Natural'First));
   begin
      Assert (not (Equivalent_Values (Key1, Key2)), "key1 : (space)0  key2 : 0");
   end Not_Numeric_To_String_0;

   procedure Numeric_To_String_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "0";
      Key2 : constant String := To_String (Numeric_To_String (Natural'First));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : 0   key2 : 0");
   end Numeric_To_String_0;

   procedure Not_Numeric_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := " 1";
      Key2 : constant String := To_String (Numeric_To_String (1));
   begin
      Assert (not (Equivalent_Values (Key1, Key2)), "key1 : (space)1  key2 : 1");
   end Not_Numeric_To_String_1;

   procedure Numeric_To_String_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "1";
      Key2 : constant String := To_String (Numeric_To_String (1));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : 1  key2 : 1");
   end Numeric_To_String_1;

   procedure Not_Numeric_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := " 7";
      Key2 : constant String := To_String (Numeric_To_String (7));
   begin
      Assert (not (Equivalent_Values (Key1, Key2)), "key1 : (space)7  key2 : 7");
   end Not_Numeric_To_String_2;

   procedure Numeric_To_String_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "7";
      Key2 : constant String := To_String (Numeric_To_String (7));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : 7  key2 : 7");
   end Numeric_To_String_2;

   procedure Numeric_To_String_3 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "A";
      Key2 : constant String := To_String (Numeric_To_String (10));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : A  key2 : A");
   end Numeric_To_String_3;

   procedure Numeric_To_String_4 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "F";
      Key2 : constant String := To_String (Numeric_To_String (15));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : F  key2 : F");
   end Numeric_To_String_4;


   procedure Numeric_To_String_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant String := "Z";
      Key2 : constant String := To_String (Numeric_To_String (35));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Z  key2 : Z");
   end Numeric_To_String_5;

   procedure Register_Tests (T : in out T_Print_Test_Case) is
      use AUnit.Test_Cases.Registration;
   begin
      Test_Last;
      Register_Routine (T, Number_To_String_0'Access, "Number_To_String (Natural'First, Base_2) = 0");
      Register_Routine (T, Number_To_String_1'Access, "Number_To_String (Natural'First, Base_16) = 0");
      Register_Routine (T, Number_To_String_2'Access, "Number_To_String (2, Base_2) = 10");
      Register_Routine (T, Number_To_String_3'Access, "Number_To_String (3, Base_3) = 10");
      Register_Routine (T, Number_To_String_4'Access, "Number_To_String (4, Base_4) = 10");
      Register_Routine (T, Number_To_String_5'Access, "Number_To_String (5, Base_5) = 10");
      Register_Routine (T, Number_To_String_6'Access, "Number_To_String (6, Base_6) = 10");
      Register_Routine (T, Number_To_String_7'Access, "Number_To_String (7, Base_7) = 10");
      Register_Routine (T, Number_To_String_8'Access, "Number_To_String (8, Base_8) = 10");
      Register_Routine (T, Number_To_String_9'Access, "Number_To_String (9, Base_9) = 10");
      Register_Routine (T, Number_To_String_10'Access, "Number_To_String (10, Base_10) = 10");
      Register_Routine (T, Number_To_String_11'Access, "Number_To_String (11, Base_11) = 10");
      Register_Routine (T, Number_To_String_12'Access, "Number_To_String (12, Base_12) = 10");
      Register_Routine (T, Number_To_String_13'Access, "Number_To_String (13, Base_13) = 10");
      Register_Routine (T, Number_To_String_14'Access, "Number_To_String (14, Base_14) = 10");
      Register_Routine (T, Number_To_String_15'Access, "Number_To_String (15, Base_15) = 10");
      Register_Routine (T, Number_To_String_16'Access, "Number_To_String (16, Base_16) = 10");
      Register_Routine (T, Number_To_String_17'Access,
			"Number_To_String (Natural'Last, Base_2) = 1111111111111111111111111111111");
      Register_Routine (T, Number_To_String_18'Access, "Number_To_String (Natural'Last, Base_16) = 7FFFFFFF");

      Register_Routine (T, Base_To_String_0'Access, "Base_To_String (Natural'First, 2) = 0");
      Register_Routine (T, Base_To_String_1'Access, "Base_To_String (Natural'First, 16) = 0");
      Register_Routine (T, Base_To_String_2'Access, "Base_To_String (25, 2) = 110001");
      Register_Routine (T, Base_To_String_3'Access, "Base_To_String (25, 8) = 29");
      Register_Routine (T, Base_To_String_4'Access, "Base_To_String (25, 16) = 19");
      Register_Routine (T, Base_To_String_5'Access, "Base_To_String (257, 16) = A1");
      Register_Routine (T, Base_To_String_6'Access, "Base_To_String (Natural'Last, 2) = 1111111111111111111111111111111");
      Register_Routine (T, Base_To_String_7'Access, "Base_To_String (Natural'Last, 16) = 7FFFFFF");
      Register_Routine (T, Base_To_String_8'Access, "Base_To_String (Natural'Last, Natural'Last) = 10");

      Register_Routine (T, Preformat_0'Access, "Preformat (1, 2) = 01");
      Register_Routine (T, Preformat_1'Access, "Preformat (1001, 2) = 1001");
      Register_Routine (T, Preformat_2'Access, "Preformat (1001, 8) = 00001001");
      Register_Routine (T, Preformat_3'Access, "Preformat (abc, 8) = 00000abc");
      Register_Routine (T, Preformat_4'Access, "Preformat (#@., 4) = 0#@.");
      Register_Routine (T, Preformat_5'Access, "Preformat (, 4) = 0000");
      Register_Routine (T, Preformat_6'Access, "Preformat ( , 4) = 000 ");

      Register_Routine (T, Not_Numeric_To_String_0'Access, "'(space)0' /= '0'");
      Register_Routine (T, Numeric_To_String_0'Access, "'0' = '0'");
      Register_Routine (T, Not_Numeric_To_String_1'Access, "'(space)1' /= '1'");
      Register_Routine (T, Numeric_To_String_1'Access, "'1' = '1'");
      Register_Routine (T, Not_Numeric_To_String_2'Access, " '(space)7' /= '7'");
      Register_Routine (T, Numeric_To_String_2'Access, "'7' = '7'");
      Register_Routine (T, Numeric_To_String_3'Access, "'A' = 'A'");
      Register_Routine (T, Numeric_To_String_4'Access, "'F' = 'F'");
      Register_Routine (T, Numeric_To_String_5'Access, "'Z' = 'Z'");
   end Register_Tests;

   function Name (T : T_Print_Test_Case) return Message_String is
      pragma Unreferenced (T);
   begin
      return new String'("print numeric module tests");
   end Name;

end Print.Numeric.Unit_Test;
