with AUnit.Test_Suites; use AUnit.Test_Suites;
with AUnit.Run;
with AUnit.Reporter.Text;

with Print.Numeric.Unit_Test;
with Print_Utils_Base.Unit_Test;
with Print.Numeric.Binary.Unit_Test;
with Print.Numeric.Hexadecimal.Unit_Test;
with Read.Numeric.Unit_Test;


procedure Print_Canvas is

   function Suite return Access_Test_Suite;
   function Suite return Access_Test_Suite is
      Result : constant Access_Test_Suite := new Test_Suite;
   begin

      AUnit.Test_Suites.Add_Test (Result, new  Print_Utils_Base.Unit_Test.T_Print_Test_Case);
      AUnit.Test_Suites.Add_Test (Result, new  Print.Numeric.Binary.Unit_Test.T_Print_Test_Case);
      AUnit.Test_Suites.Add_Test (Result, new  Print.Numeric.Hexadecimal.Unit_Test.T_Print_Test_Case);
      AUnit.Test_Suites.Add_Test (Result, new  Print.Numeric.Unit_Test.T_Print_Test_Case);
      AUnit.Test_Suites.Add_Test (Result, new  Read.Numeric.Unit_Test.T_Print_Test_Case);
      return Result;
   end Suite;

   procedure Run is new AUnit.Run.Test_Runner (Suite);
   Reporter : AUnit.Reporter.Text.Text_Reporter;
begin
   Run (Reporter);
end Print_Canvas;
