with AUnit; use AUnit;
with AUnit.Test_Cases;
use AUnit.Test_Cases;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

--  <description>
--  This package for test differents function of the package
--  print_utils_base
--  </description>
--  <group>Print_unit_test</group>

package Print_Utils_Base.Unit_Test is
   type T_Mes_Index is new Natural range 0 .. 7;

   type T_Tab_Octal is array (T_Mes_Index'Range) of Unbounded_String;
   Mon_Tab : T_Tab_Octal := (0 => To_Unbounded_String ("0"),
			     1 => To_Unbounded_String ("1"),
			     2 => To_Unbounded_String ("2"),
			     3 => To_Unbounded_String ("3"),
			     4 => To_Unbounded_String ("4"),
			     5 => To_Unbounded_String ("5"),
			     6 => To_Unbounded_String ("6"),
			     7 => To_Unbounded_String ("7")
			    );


   type T_Print_Test_Case is new AUnit.Test_Cases.Test_Case with record
      Left_Values : T_Mes_Index;
   end record;


   procedure Tear_Down (T : in out T_Print_Test_Case);


   procedure Test_Equivalent_String_Octal_loop (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure  Register_Tests (T : in out T_Print_Test_Case);
   --  <summary>This a procedure to register test procedure in AUnit</summary>
   --  <parameter name="T">That a global object of all tests</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Name (T : T_Print_Test_Case) return Message_String;
   --  <summary>This function give a name to module test in this package and return Message_String</summary>
   --  <parameter name="T">That a global object of all tests</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Ada AUnit sources</seealso>

   function Equivalent_Values (Val1, Val2 : String) return Boolean;
   --  <summary>This function test that values are equal and return a Boolean</summary>
   --  <parameter name="Val1">A String</parameter>
   --  <parameter name="Val2">A String</parameter>
   --  <exception>No exception</exception>
   --  <seealso>Nothing</seealso>

   procedure Test_Equivalent_String_Hexa_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Test_Equivalent_String_Hexa_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_6 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_7 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_8 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_9 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_10 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_11 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_12 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_13 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_14 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Hexa_F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Hexadecimal) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>


   --  procedure Test_Equivalent_String_Octal_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_2 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_3 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_4 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_5 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_6 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>
   --  procedure Test_Equivalent_String_Octal_7 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  --  <summary>This a procedure to test To_String (N : octal) function</summary>
   --  --  <parameter name="T">That a global object of all test</parameter>
   --  --  <exception>No exceptions</exception>
   --  --  <seealso>Nothing</seealso>

   procedure Test_Equivalent_String_Binaire_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Binaire) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_String_Binaire_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test To_String (N : Binaire) function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

   procedure Test_Equivalent_Numeric_0 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_Numeric_1 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_Numeric_7 (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_Numeric_A (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_Numeric_F (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>
   procedure Test_Equivalent_Numeric_Z (T : in out AUnit.Test_Cases.Test_Case'Class);
   --  <summary>This a procedure to test Numeric_To_String function</summary>
   --  <parameter name="T">That a global object of all test</parameter>
   --  <exception>No exceptions</exception>
   --  <seealso>Nothing</seealso>

end Print_Utils_Base.Unit_Test;
