with Read.Numeric; with Print.Numeric;
with AUnit.Assertions; use AUnit.Assertions;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body Read.Numeric.Unit_Test is

   function Equivalent_Values (Val1, Val2 : Integer) return Boolean is
   begin
      return Val1 = Val2;
   end Equivalent_Values;

   function Name (T : T_Print_Test_Case) return Message_String is
      pragma Unreferenced (T);
   begin
      return new String'("read numeric module tests");
   end Name;



   procedure Read_Hex_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0x00"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 0 , key2 : Integer => '0x00'");
   end Read_Hex_Interne_0;

   procedure Read_Hex_Interne_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0X0001"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '0X0001");
   end  Read_Hex_Interne_0X0001;


   procedure Read_Hex_Interne_0xA (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 10;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0xA"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 10 , key2 : Integer => '0xA'");
   end Read_Hex_Interne_0xA;

   procedure Read_Hex_Interne_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 15;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0x000F"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 15 , key2 : Integer => '0x000F'");
   end Read_Hex_Interne_0x000F;


   procedure Read_Hex_Interne_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 44401;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0xAD71"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 44401 , key2 : Integer => '0xAD71'");
   end Read_Hex_Interne_0xAD71;

   procedure Read_Hex_Interne_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Hex_Interne (To_Unbounded_String ("0x7FFFFFFF"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 2147483647 , key2 : Integer => '0xAD71'");
   end Read_Hex_Interne_0x7FFFFFFF;





   procedure Read_Hex_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0x00"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 0 , key2 : Integer => '0x00'");
   end Read_Hex_0;

   procedure Read_Hex_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0X0001"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '0X0001");
   end  Read_Hex_0X0001;



   procedure Read_Hex_0xA (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 10;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0xA"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 10 , key2 : Integer => '0xA'");
   end Read_Hex_0xA;

   procedure Read_Hex_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 15;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0x000F"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 15 , key2 : Integer => '0x000F'");
   end Read_Hex_0x000F;


   procedure Read_Hex_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 44401;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0xAD71"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 44401 , key2 : Integer => '0xAD71'");
   end Read_Hex_0xAD71;

   procedure Read_Hex_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Hex (To_Unbounded_String ("0x7FFFFFFF"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 2147483647 , key2 : Integer => '0xAD71'");
   end Read_Hex_0x7FFFFFFF;






   procedure Read_Dec_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("0"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 0 , key2 : Integer => '0'");
   end Read_Dec_Interne_0;

   procedure Read_Dec_Interne_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("1"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '1'");
   end  Read_Dec_Interne_1;

   procedure Read_Dec_Interne_255 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 255;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("255"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 255 , key2 : Integer => '0001");
   end Read_Dec_Interne_255;

   procedure Read_Dec_Interne_256 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 256;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("256"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 256 , key2 : Integer => '256'");
   end Read_Dec_Interne_256;

   procedure Read_Dec_Interne_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("2147483647"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer =>  2147483647, key2 : Integer => '2147483647'");
   end Read_Dec_Interne_2147483647;

   procedure Read_Dec_Interne_H8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 8;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("16#8#"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 8 , key2 : Integer => '16#8#'");
   end Read_Dec_Interne_H8;


   procedure Read_Dec_Interne_HC (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 12;
      Key2 : constant Integer := Read_Dec_Interne (To_Unbounded_String ("16#C#"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 12 , key2 : Integer => '16#C#'");
   end Read_Dec_Interne_HC;





   procedure Read_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("0"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 0 , key2 : Integer => '0'");
   end Read_Dec_0;

   procedure Read_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("1"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '1'");
   end  Read_Dec_1;

   procedure Read_Dec_255 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 255;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("255"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 255 , key2 : Integer => '0001");
   end Read_Dec_255;

   procedure Read_Dec_256 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 256;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("256"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 256 , key2 : Integer => '256'");
   end Read_Dec_256;

   procedure Read_Dec_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("2147483647"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer =>  2147483647, key2 : Integer => '2147483647'");
   end Read_Dec_2147483647;


   procedure Read_Dec_H8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 8;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("16#8#"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 8 , key2 : Integer => '16#8#'");
   end Read_Dec_H8;


   procedure Read_Dec_HC (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 12;
      Key2 : constant Integer := Read_Dec (To_Unbounded_String ("16#C#"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 12 , key2 : Integer => '16#C#'");
   end Read_Dec_HC;





   procedure Read_Hex_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer =>  0, key2 : Integer => '0'");
   end Read_Hex_Dec_0;


   procedure Read_Hex_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("1"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '1'");
   end  Read_Hex_Dec_1;

   procedure Read_Hex_Dec_255 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 255;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("255"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 255 , key2 : Integer => '0001");
   end Read_Hex_Dec_255;

   procedure Read_Hex_Dec_256 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 256;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("256"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 256 , key2 : Integer => '256'");
   end Read_Hex_Dec_256;

   procedure Read_Hex_Dec_2147483647 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("2147483647"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer =>  2147483647, key2 : Integer => '2147483647'");
   end Read_Hex_Dec_2147483647;




   procedure Read_Hex_Dec_0x00 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 0;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0x00"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 0 , key2 : Integer => '0x00'");
   end Read_Hex_Dec_0x00;

   procedure Read_Hex_Dec_0X0001 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 1;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0X0001"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 1 , key2 : Integer => '0X0001");
   end  Read_Hex_Dec_0X0001;



   procedure Read_Hex_Dec_0xA (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 10;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0xA"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 10 , key2 : Integer => '0xA'");
   end Read_Hex_Dec_0xA;

   procedure Read_Hex_Dec_0x000F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 15;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0x000F"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 15 , key2 : Integer => '0x000F'");
   end Read_Hex_Dec_0x000F;


   procedure Read_Hex_Dec_0xAD71 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 44401;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0xAD71"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 44401 , key2 : Integer => '0xAD71'");
   end Read_Hex_Dec_0xAD71;

   procedure Read_Hex_Dec_0x7FFFFFFF (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Key1 : constant Integer := 2147483647;
      Key2 : constant Integer := Read_Hex_Dec (To_Unbounded_String ("0x7FFFFFFF"));
   begin
      Assert (Equivalent_Values (Key1, Key2), "key1 : Integer => 2147483647 , key2 : Integer => '0xAD71'");
   end Read_Hex_Dec_0x7FFFFFFF;


   procedure Test_Exception_Dec_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Dec :  Integer;
      pragma Unreferenced (Dec);
   begin
      Dec := Read.Numeric.Read_Dec (To_Unbounded_String ("0x00"));
      Assert (False, "Exception not raise, it's correct value parameter");
   exception
      when  Print.Numeric.Wrong_Type =>
	 Assert (True, "Exception raise, it's not correct value parameter");
      when others =>
	 Assert (False, "Exception not raise, it's correct value parameter");
   end Test_Exception_Dec_0;

   procedure Test_Exception_Dec_F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Dec :  Integer;
      pragma Unreferenced (Dec);
   begin
      Dec := Read.Numeric.Read_Dec (To_Unbounded_String ("0xF"));
      Assert (False, "Exception not raise, it's correct value parameter");
   exception
      when  Print.Numeric.Wrong_Type =>
	 Assert (True, "Exception raise, it's not correct value parameter");
      when others =>
	 Assert (False, "Exception not raise, it's correct value parameter");
   end Test_Exception_Dec_F;


   procedure Test_Exception_Dec_Interne_0 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Dec :  Integer;
      pragma Unreferenced (Dec);
   begin
      Dec := Read.Numeric.Read_Dec_Interne (To_Unbounded_String ("0x0000"));
      Assert (False, "Exception not raise, it's correct value parameter");
   exception
      when  Constraint_Error =>
	 Assert (True, "Exception raise, it's not correct value parameter");
      when others =>
	 Assert (False, "Exception not raise, it's correct value parameter");
   end Test_Exception_Dec_Interne_0;


   procedure Test_Exception_Dec_Interne_F (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Dec :  Integer;
      pragma Unreferenced (Dec);
   begin
      Dec := Read.Numeric.Read_Dec_Interne (To_Unbounded_String ("0xF"));
      Assert (False, "Exception not raise, it's correct value parameter");
   exception
      when  Constraint_Error =>
	 Assert (True, "Exception raise, it's not correct value parameter");
      when others =>
	 Assert (False, "Exception not raise, it's correct value parameter");
   end Test_Exception_Dec_Interne_F;

   procedure Test_Exception_Hex_Interne_8 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex_Interne (To_Unbounded_String ("8"));
      Assert (False, "exception has faillure");
   exception
      when Constraint_Error =>
	 Assert (True, "exception has complete");
      when others =>
	 Assert (False, "exception has faillure");
   end Test_Exception_Hex_Interne_8;

   procedure Test_Exception_Hex_Interne_G (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex_Interne (To_Unbounded_String ("0xG"));
      Assert (False, "exception has faillure");
   exception
      when Constraint_Error =>
	 Assert (True, "exception has complete");
      when others =>
	 Assert (False, "exception has faillure");
   end Test_Exception_Hex_Interne_G;

   procedure Test_Exception_Hex_Interne_Diese (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex_Interne (To_Unbounded_String ("16#A#"));
      Assert (False, "exception faillure");
   exception
      when Constraint_Error =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_Interne_Diese;

   procedure Test_Exception_Hex_G (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex (To_Unbounded_String ("0xG"));
      Assert (False, "exception faillure");
   exception
      when Print.Numeric.Wrong_Type =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_G;

   procedure Test_Exception_Hex_5 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex (To_Unbounded_String ("5"));
      Assert (False, "exception faillure");
   exception
      when Print.Numeric.Wrong_Type =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_5;


   procedure Test_Exception_Hex_Diese (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Hex : Integer;
      pragma Unreferenced (Hex);
   begin
      Hex := Read.Numeric.Read_Hex (To_Unbounded_String ("16#A#"));
      Assert (False, "exception faillure");
   exception
      when Print.Numeric.Wrong_Type =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_Diese;


   procedure Test_Exception_Hex_Dec_1 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Var : Integer;
      pragma Unreferenced (Var);
   begin
      Var := Read.Numeric.Read_Hex_Dec (To_Unbounded_String ("0xG"));
      Assert (False, "exception faillure");
   exception
      when Print.Numeric.Wrong_Type =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_Dec_1;

   procedure Test_Exception_Hex_Dec_2 (T : in out AUnit.Test_Cases.Test_Case'Class) is
      pragma Unreferenced (T);
      Var : Integer;
      pragma Unreferenced (Var);
   begin
      Var := Read.Numeric.Read_Hex_Dec (To_Unbounded_String ("A"));
      Assert (False, "exception faillure");
   exception
      when Print.Numeric.Wrong_Type =>
	 Assert (True, "exception complete");
      when others =>
	 Assert (False, "exception faillure");
   end Test_Exception_Hex_Dec_2;


   procedure Register_Tests (T : in out T_Print_Test_Case) is
      use AUnit.Test_Cases.Registration;
   begin
      Register_Routine (T,  Read_Hex_Interne_0'Access, " Read_Hex_Interne ('0x00') = 0");
      Register_Routine (T,  Read_Hex_Interne_0X0001'Access, " Read_Hex_Interne ('0X0001') = 1");
      Register_Routine (T,  Read_Hex_Interne_0xA'Access, " Read_Hex_Interne ('0xA') = 10");
      Register_Routine (T,  Read_Hex_Interne_0x000F'Access, " Read_Hex_Interne ('0x000F') = 15");
      Register_Routine (T,  Read_Hex_Interne_0xAD71'Access, " Read_Hex_Interne ('0xAD71') = 44401");
      Register_Routine (T,  Read_Hex_Interne_0x7FFFFFFF'Access, " Read_Hex_Interne ('0x7FFFFFFF') = 2147483647");

      Register_Routine (T,  Read_Hex_0'Access, " Read_Hex ('0x00') = 0");
      Register_Routine (T,  Read_Hex_0X0001'Access, " Read_Hex ('0X0001') = 1");
      Register_Routine (T,  Read_Hex_0xA'Access, " Read_Hex ('0xA') = 10");
      Register_Routine (T,  Read_Hex_0x000F'Access, " Read_Hex ('0x000F') = 15");
      Register_Routine (T,  Read_Hex_0xAD71'Access, " Read_Hex ('0xAD71') = 44401");
      Register_Routine (T,  Read_Hex_0x7FFFFFFF'Access, " Read_Hex ('0x7FFFFFFF') = 2147483647");

      Register_Routine (T,  Read_Dec_Interne_0'Access, " Read_Dec_Interne ('0') = 0");
      Register_Routine (T,  Read_Dec_Interne_1'Access, " Read_Dec_Interne ('1') = 1");
      Register_Routine (T,  Read_Dec_Interne_255'Access, " Read_Dec_Interne ('255') = 255");
      Register_Routine (T,  Read_Dec_Interne_256'Access, " Read_Dec_Interne ('256') =256");
      Register_Routine (T,  Read_Dec_Interne_2147483647'Access, " Read_Dec_Interne ('2147483647') = 2147483647");
      Register_Routine (T,  Read_Dec_Interne_H8'Access, " Read_Dec_Interne ('16#8#') = 8");
      Register_Routine (T,  Read_Dec_Interne_HC'Access, " Read_Dec_Interne ('16#C#') = 12");

      Register_Routine (T,  Read_Dec_0'Access, " Read_Dec ('0') = 0");
      Register_Routine (T,  Read_Dec_1'Access, " Read_Dec ('1') = 1");
      Register_Routine (T,  Read_Dec_255'Access, " Read_Dec ('255') = 255");
      Register_Routine (T,  Read_Dec_256'Access, " Read_Dec ('256') =256");
      Register_Routine (T,  Read_Dec_2147483647'Access, " Read_Dec ('2147483647') = 2147483647");
      Register_Routine (T,  Read_Dec_H8'Access, " Read_Dec ('16#8#') = 8");
      Register_Routine (T,  Read_Dec_HC'Access, " Read_Dec ('16#C#') = 12");

      Register_Routine (T,  Read_Hex_Dec_0'Access, " Read_Hex_Dec ('0') = 0");
      Register_Routine (T,  Read_Hex_Dec_1'Access, " Read_Hex_Dec ('1') = 1");
      Register_Routine (T,  Read_Hex_Dec_255'Access, " Read_Hex_Dec ('255') = 255");
      Register_Routine (T,  Read_Hex_Dec_256'Access, " Read_Hex_Dec ('256') =256");
      Register_Routine (T,  Read_Hex_Dec_2147483647'Access, " Read_Hex_Dec ('2147483647') = 2147483647");
      Register_Routine (T,  Read_Hex_Dec_0x00'Access, " Read_Hex_Dec ('0x00') = 0");
      Register_Routine (T,  Read_Hex_Dec_0X0001'Access, " Read_Hex_Dec ('0X0001') = 1");
      Register_Routine (T,  Read_Hex_Dec_0xA'Access, " Read_Hex_Dec ('0xA') = 10");
      Register_Routine (T,  Read_Hex_Dec_0x000F'Access, " Read_Hex_Dec ('0x000F') = 15");
      Register_Routine (T,  Read_Hex_Dec_0xAD71'Access, " Read_Hex_Dec ('0xAD71') = 44401");
      Register_Routine (T,  Read_Hex_Dec_0x7FFFFFFF'Access, " Read_Hex_Dec ('0x7FFFFFFF') = 2147483647");

      Register_Routine (T, Test_Exception_Dec_Interne_0'Access,
			"Test exception  Wrong_Type of Read_Dec_Interne_0 for value 0x00");
      Register_Routine (T, Test_Exception_Dec_Interne_F'Access,
			"Test exception  Wrong_Type of Read_Dec_Interne_F for value 0xF");
      Register_Routine (T, Test_Exception_Dec_0'Access,
			"Test exception Constraint_Error of Read_Dec for value 0x00");
      Register_Routine (T, Test_Exception_Dec_F'Access,
			"Test exception Constraint_Error of Read_Dec for value 0xF");
      Register_Routine (T, Test_Exception_Hex_Interne_8'Access,
			"Test exception constraint_error of read_hex_interne to value 8");
      Register_Routine (T, Test_Exception_Hex_Interne_G'Access,
			"Test exception constraint_error of read_hex_interne to value 0xG");
      Register_Routine (T, Test_Exception_Hex_Interne_Diese'Access,
			"test exception constraint_error of read_hex_interne to value 16#A#");
      Register_Routine (T, Test_Exception_Hex_G'Access, "test exception wrong_type of read_hex to value 0xG");
      Register_Routine (T, Test_Exception_Hex_5'Access, "test exception wrong_type of read_hex to value 5");
      Register_Routine (T, Test_Exception_Hex_Diese'Access, "test exception wrong_type of read_hex to value 16#A#");
      Register_Routine (T, Test_Exception_Hex_Dec_1'Access, "test exception wrong_type of read_hex_dec to value 0xG");
      Register_Routine (T, Test_Exception_Hex_Dec_2'Access, "test exception wrong_type of read_hex_dec to value A");
   end Register_Tests;
end Read.Numeric.Unit_Test;
